igroup        group     Newscrn_text
              assume    cs: igroup
              public    SCRNSAVE,SCRNREST
Newscrn_text  segment   byte public 'CODE'

SCRNSAVE      proc      far
              push      bp                    ;Save for BASIC
              mov       bp,sp                 ;
              push      es                    ;
              mov       bx,6[bp]              ;Get location of Array
              mov       si,[bx]               ;Set up in Source
              xor       bx,bx                 ; Set destination index to 0
              mov       di,bx                 ;
              call      GET_SET
              push      ax
              mov       ax,ds                 ;exchange DS and ES
              mov       bx,es                 ;since we are moving from screen
              mov       ds,bx                 ;to array
              mov       es,ax
              xchg      si,di
              pop       ax
              call      GO                    ;do it
              mov       ax,es                 ;restore DS
              mov       ds,ax
              pop       es
              pop       bp
              ret       2
SCRNSAVE      endp

SCRNREST      proc      far
              push      bp
              mov       bp,sp
              push      es
              mov       bx,6[bp]              ; Get location of Array
              mov       si,[bx]               ; set up in source
              xor       bx,bx                 ; Set destination index to 0
              mov       di,bx                 ;
              call      GET_SET
              call      GO
              pop       es
              pop       bp
              ret       2
SCRNREST      endp

GET_SET       proc      near

              mov  ax,0
              mov  ah,15                      ;Video mode BIOS Call
              int  010H                       ;Do the BIOS Call
              cmp  al,07H                     ;See if it's Monochrome
              jz   is_mono                    ;Yes
              mov  ax,0B800H                  ;Set it up for C/G
              jmp  ok                         ;
is_mono:      mov  ax,0B000H                  ;Set it up for Monochrome

ok:           mov       es,ax
              cld                             ; set up for auto increment
              mov       ah,6                  ; number of blocks to copy
              ret
GET_SET       endp

GO            proc      near

begin:        mov       cx,240                ; number of words to move during VRTCE
              mov       dx,3DAH               ; C/G adapter status port
              cli                             ; disable interrupts

wait_vert_refresh:

              in        al,dx                 ; read status
              test      al,8                  ; test vertical retrace bit
              jnz       wait_vert_refresh     ; loop until in refresh

wait_vert_retrace:

              in        al,dx                 ;read status
              test      al,8                  ;test vertical retrace bit
              jz        wait_vert_retrace     ;loop until retrace starts
              rep       movsw                 ;move a block of words

              mov       cx,188                ;number of bytes to move during
                                              ;horizontal retrace periods

              cmp       cx,0                  ;anything to copy
              jz        short bypass_horiz    ;no - bypass horiz.
              mov       dx,3DAH

wait_horiz_refresh:

              in        al,dx                 ;read status
              test      al,1                  ;test horizontal retrace bit
              jnz       wait_horiz_refresh    ;loop until in a retrace

wait_horiz_retrace:

              in        al,dx                 ;read status
              test      al,1                  ;test horizontal retrace bit
              jz        wait_horiz_retrace    ;loop until retrace starts

              movsb                           ;copy a byte

              loop      wait_horiz_refresh

bypass_horiz:

              dec       ah                    ;reduce the block count
              cmp       ah,0                  ;done?
              jnz       short begin

              sti
              ret

GO            endp

Newscrn_text  ends
              end
