PROGRAM Pic_Bld;
{ CONVERTS FILES FROM BASIC BLOAD FORMAT TO PC-DEMO .PIC FORMAT }

  CONST
    Columns40           = 40;       { COLUMNS FROM 1 TO 40 }
    Columns80           = 80;       { COLUMNS FROM 1 TO 80 }
    LastLine            = 25;       { LINES FROM 1 TO 25 }
    MaxtString          = 76;       { MAX CHARS IN FILE NAME W/ PATH AND EXT }
    FourKB              = 4000;     { FILE SIZE OF 80-COLUMN PICTURE }
    TwoKB               = 2000;     { FILE SIZE OF 40-COLUMN PICTURE }
    Page40              = 2048;     { OFFSET FOR MULTIPLE PAGES IN 40-COL }
    Page80              = 4096;     { OFFSET FOR MULTIPLE PAGES IN 80-COL }
    BloadCode           = 253;      { FIRST BYTE OF A .BLD FILE }
    EndOfFile           = 026;      { ASCII CODE FOR END OF FILE IN .BLD FILE }
    BloadExt            = '.BLD';   { FILE EXTENSION FOR BLOAD FILES }
    PictureExt          = '.PIC';   { FILE EXTENSION FOR FULL PICTURES }
    Null                = '';       { NULL STRING }

  TYPE
    N_PictureType       = ARRAY [1..LastLine, 1..Columns40] OF Integer;
                                    { ARRAY OF 40-COLUMN PICTURE DATA }
    W_PictureType       = ARRAY [1..LastLine, 1..Columns80] OF Integer;
                                    { ARRAY OF 80-COLUMN PICTURE DATA }

    N_BloadType         = ARRAY [1..Page40] OF Byte;
                                    { ARRAY OF 40-COLUMN BLOAD FILE DATA }
    W_BloadType         = ARRAY [1..Page80] OF Byte;
                                    { ARRAY OF 80-COLUMN BLOAD FILE DATA }

    ParString           = String [255];
                                    { VARIABLE LENGTH STRING PARAMETER TYPE }

  VAR
    Code,
    HighLength,
    I,
    LowLength          : Byte;

    Size               : Integer;

    IName,
    OName              : ParString;

    W_Picture          : W_PictureType;
                                    { THE 80-COLUMN PICTURE }

    N_Picture          : N_PictureType Absolute W_Picture;
                                    { THE 40-COLUMN PICTURE }

    W_InData           : W_BloadType;
    N_InData           : N_BloadType Absolute W_Indata;

    N_InFile           : FILE OF N_BloadType;
    W_InFile           : FILE OF W_BloadType;

    N_OutFile          : FILE OF N_PictureType;
    W_OutFile          : FILE OF W_PictureType;

    TestFile           : FILE OF Byte;

    N_OutPtr           : ^ N_PictureType;
    W_OutPtr           : ^ W_PictureType;


  FUNCTION Exist (FileName : ParString) : Boolean;
  { SEES IF A FILE EXISTS }

    VAR
      TestFile  : FILE;

    BEGIN    { Exist }
      Assign (TestFile, FileName);

{$I-}

      Reset (TestFile);

{$I+}

      Exist := (IOResult = 0);
      Close (TestFile);
    END;     { Exist }



  PROCEDURE ConvertCase (VAR Strng : ParString);
  { CONVERTS STRINGS TO UPPER CASE }

    VAR
      I : Byte;

    BEGIN    { ConvertCase }
      FOR I := 1 TO Length (Strng) DO
        Strng [I] := UpCase (Strng [I]);
    END;     { ConvertCase }


  BEGIN    { Bld_Pic }
    IName := Null;
    IF ParamCount = 0
      THEN
        BEGIN
          Writeln ('Command must be of form: BLD_PIC <name>');
          Exit;
        END;
    IName := ParamStr (1);
    Convertcase (IName);
    OName := IName + PictureExt;
    IName := IName + BloadExt;
    IF NOT Exist (IName)
      THEN
       BEGIN
         Writeln ('ERROR! File not found ' + IName);
         Exit;
       END;
      Assign (TestFile, IName);
      Reset (TestFile);
      Read (TestFile, Code);
      FOR I := 2 TO 6 DO
        Read (TestFile, LowLength); { 6TH AND 7TH BYTES STORE THE LENGTH }
      Read (TestFile, HighLength);
      Size := HighLength * $100 + LowLength;
      Close (TestFile);
      IF (IOResult <> 0) OR (Code <> BloadCode) OR
         NOT (((Size) = TwoKB) OR (Size = FourKB))
        THEN
          BEGIN
            Writeln ('ERROR! File is not of BASIC BLOAD Format.');
            Exit;
          END;
      IF Size = TwoKB
        THEN
          BEGIN
            Assign (N_InFile, IName);
            Reset (N_InFile);
            Read (N_InFile, N_InData);
            N_OutPtr := Ptr (Seg (N_InData), Ofs (N_InData) + 7);
            N_Picture := N_OutPtr ^;   { TRANSFER PICTURE DATA }
            Assign (N_OutFile, OName);
            Rewrite (N_OutFile);
            Write (N_OutFile, N_Picture);
            Close (N_InFile);
            Close (N_OutFile);
          END
        ELSE
          BEGIN
            Assign (W_InFile, IName);
            Reset (W_InFile);
            Read (W_InFile, W_InData);
            W_OutPtr := Ptr (Seg (W_InData), Ofs (W_InData) + 7);
            W_Picture := W_OutPtr ^;       { TRANSFER PICTURE DATA }
            Assign (W_OutFile, OName);
            Rewrite (W_OutFile);
            Write (W_OutFile, W_Picture);
            Close (W_InFile);
            Close (W_OutFile);
          END;
      Writeln ('File '+ OName + ' created.');
    END.     { Bld_Pic }
